USACO River Crossing

洛谷 P2904 [USACO08MAR]跨河River Crossing

https://www.luogu.org/problem/P2904

JDOJ 2574: USACO 2008 Mar Silver 3.River Crossing

https://neooj.com:8082/oldoj/problem.php?id=2574

题目描述

Farmer John is herding his N cows (1 <= N <= 2,500) across the expanses of his farm when he finds himself blocked by a river. A single raft is available for transportation.

FJ knows that he must ride on the raft for all crossings and that that adding cows to the raft makes it traverse the river more slowly.

When FJ is on the raft alone, it can cross the river in M minutes (1 <= M <= 1000). When the i cows are added, it takes M_i minutes (1 <= M_i <= 1000) longer to cross the river than with i-1 cows (i.e., total M+M_1 minutes with one cow, M+M_1+M_2 with two, etc.). Determine the minimum time it takes for Farmer John to get all of the cows across the river (including time returning to get more cows).

Farmer John以及他的N(1 <= N <= 2,500)头奶牛打算过一条河,但他们所有的渡河工具,仅仅是一个木筏。 由于奶牛不会划船,在整个渡河过程中,FJ必须始终在木筏上。在这个基础上,木筏上的奶牛数目每增加1,FJ把木筏划到对岸就得花更多的时间。 当FJ一个人坐在木筏上,他把木筏划到对岸需要M(1 <= M <= 1000)分钟。当木筏搭载的奶牛数目从i-1增加到i时,FJ得多花M_i(1 <= M_i <= 1000)分钟才能把木筏划过河(也就是说,船上有1头奶牛时,FJ得花M+M_1分钟渡河;船上有2头奶牛时,时间就变成M+M_1+M_2分钟。后面的依此类推)。那么,FJ最少要花多少时间,才能把所有奶牛带到对岸呢?当然,这个时间得包括FJ一个人把木筏从对岸划回来接下一批的奶牛的时间。

输入格式

* Line 1: Two space-separated integers: N and M

* Lines 2..N+1: Line i+1 contains a single integer: M_i

输出格式

* Line 1: The minimum time it takes for Farmer John to get all of the cows across the river.

输入输出样例

输入 #1
5 10 
3 
4 
6 
100 
1 
输出 #1
50 

说明/提示

There are five cows. Farmer John takes 10 minutes to cross the river alone, 13 with one cow, 17 with two cows, 23 with three, 123 with four, and 124 with all five.

Farmer John can first cross with three cows (23 minutes), then return (10 minutes), and then cross with the last two (17 minutes). 23+10+17 = 50 minutes total.

扫描二维码关注公众号,回复: 6884828 查看本文章

一下子就想到DP,但是这个数据处理会很麻烦。

但是还是应该循规蹈矩地一步一步走DP的流程。

我们设dp[i]表示把i头奶牛送过河的最小时间。

那么我们怎么去转移呢?

这里用到了一个floyd思想(其实floyd就是用的动态规划的思想)

就是我们在枚举每一头奶牛的时候,再从头枚举一个断点,也就是分两批把i头奶牛送过去的最小时间。

这样就能维护出最优的dp[]数组,最终的答案就是dp[n]。

接下来是数据存储的难点。

我们应该明白,这里的m[i]数组假如要单独存放的话会极其不好处理。

那我们就采用一种常用的手段,把m_i直接设置成dp数组的初值,让其随dp的更新而更新(因为我们求得是最小时间,而我们枚举的思路不需要再保存m_i到底是哪个数)

然后就可以进行dp了。

转移方程是dp[i],dp[j]+dp[i-j]+dp[0]。

这里要注意的是,dp[0]一定要加上去,要不然就考虑不到FJ自己划船回去的时间。

代码:

#include<cstdio>
#include<algorithm>
using namespace std;
int n,m;
int dp[2501];
int main()
{
    scanf("%d%d",&n,&m);
    dp[0]=m;
    for(int i=1;i<=n;i++)
    {
        int a;
        scanf("%d",&a);
        dp[i]=dp[i-1]+a;
    }
    for(int i=2;i<=n;i++)
        for(int j=1;j<i;j++)
            dp[i]=min(dp[i],dp[j]+dp[i-j]+dp[0]);
    printf("%d",dp[n]);
    return 0;
}

猜你喜欢

转载自www.cnblogs.com/fusiwei/p/11258229.html